class Quiyo
	module Database
		DataMapper.setup(:default, "sqlite3://" + CONF["database"])

		class Love
			include DataMapper::Resource

			property :id,       Serial
			property :song,     String
			property :loved_at, Time
		end

		def love
			@love = Love.create(
			                    :song     => @mpd.current_song["file"],
			                    :loved_at => Time.now
			                    )
		end

		def loved
			Love.each { |s|
				song = @mpd.songs(s.song).first
				printf "[%s] %s : %s [%s]\n" % [
				                                s.id,
				                                colorize(song["artist"], CONF["colors"]["artist"]),
				                                colorize(song["title"],  CONF["colors"]["title"]),
				                                colorize(song["album"],  CONF["colors"]["album"])
				                               ]
			}
		end

		if(!File.exists?(CONF["database"]))
			DataMapper.auto_migrate!
		else
			DataMapper.auto_upgrade!
		end
	end
	include Database
end
