class Quiyo

	def initialize(server, port, version)
		print colorize("++", 197) + " Connecting to MPD at #{server}:#{port}..."
		@mpd = MPD.new server, port
		@mpd.connect
		print colorize("Connected!\n", 70)
		print colorize("++", 197) + " This is quiyo #{version}\n\n"
	end

	module Server
		def quit
			@mpd.disconnect
			Process.exit
		end

		def vol(arg)
			@mpd.volume=(arg)
		rescue
			p "Usage: vol [0-100]"
		end

		def search(action)
			@mpd.search(action[1], action.drop(2).join(" ")).each { |s|
				printf "%s : %s [%s]\n" % [
				                           colorize(s.artist, 99),
				                           colorize(s.title, 202),
				                           colorize(s.album, 107)
				                          ]
			}
		end

		def list(type, arg = nil)
			case type
			when "artists"
				@mpd.artists.each { |s| p s }
			when "albums"
				@mpd.albums(arg.drop(1).join(" ")).each { |s| p s }
			end
		end
	end
	include Server
end
